package com.nisum.webfluxday2.service;

import com.nisum.webfluxday2.model.ProductRequest;
import com.nisum.webfluxday2.model.ProductResponse;
import com.nisum.webfluxday2.repository.ProductRepository;
import com.nisum.webfluxday2.repository.model.Product;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import reactor.core.publisher.Flux;
import reactor.core.publisher.Mono;

@Service
public class ProductService {

    @Autowired
    ProductRepository productRepository;

    public Flux<ProductResponse> getAll() {
        Flux<Product> allProducts = productRepository.findAll();
        System.out.println(allProducts);
        return allProducts.map(product -> new ProductResponse(product));
    }

    public Mono<ProductResponse> addProduct(ProductRequest productRequest) {
        Mono<Product> newProduct = productRepository.insert(new Product(productRequest));
        return newProduct.map(product -> new ProductResponse(product));
    }
}
